/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.wahlvorschlag.boundary;

import de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class WahlvorschlagDAO extends AbstractWahlvorschlagDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Wahlvorschlag wahlvorschlag){
    getEntityManager().persist(wahlvorschlag);
  }

  public void remove(Wahlvorschlag wahlvorschlag){
    getEntityManager().remove(wahlvorschlag);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                                                    
        /**
        * Name: GebietNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT obj FROM Wahlvorschlag obj WHERE obj.gruppeImGebiet.gebiet = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Wahlvorschlag> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahlvorschlag.findByGebiet" ,  gebiet  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByGebiet( gebiet  ));
        }
        return (java.util.List<Wahlvorschlag>) cached;
        }
            return super.findByGebiet( gebiet  );
            }
                                        
        /**
        * Name: GebieteNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT obj FROM Wahlvorschlag obj WHERE obj.gruppeImGebiet.gebiet IN (?1)<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Wahlvorschlag> findByGebiete( @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebiete) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahlvorschlag.findByGebiete" ,  gebiete  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByGebiete( gebiete  ));
        }
        return (java.util.List<Wahlvorschlag>) cached;
        }
            return super.findByGebiete( gebiete  );
            }
                                            
        /**
        * Name: GruppeNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT obj FROM Wahlvorschlag obj WHERE obj.gruppeImGebiet.gruppe = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Wahlvorschlag> findByGruppe( @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahlvorschlag.findByGruppe" ,  gruppe  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByGruppe( gruppe  ));
        }
        return (java.util.List<Wahlvorschlag>) cached;
        }
            return super.findByGruppe( gruppe  );
            }
                                        
        /**
        * Name: WahlNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Wahlvorschlag o WHERE o.gruppeImGebiet.gebiet.wahl = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Wahlvorschlag> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahlvorschlag.findByWahl" ,  wahl  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahl( wahl  ));
        }
        return (java.util.List<Wahlvorschlag>) cached;
        }
            return super.findByWahl( wahl  );
            }
                    
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}